#ifndef AJLIB_LINKEDLIST_H
#define AJLIB_LINKEDLIST_H

#include "def.h"

template<class T> class LinkedListMember;

template<class T> class LinkedList : LinkedListMember<T>
{
public:
    LinkedList() { clear(); }

    void add(T* item)
    {
        item->_prev = _prev;
        _prev->_next = item;
        item->_next = this;
        _prev = item;
    }

    T* getNext(LinkedListMember<T>* item = 0)
    {
        if (item == 0)
            item = this;
        LinkedListMember<T>* next = item->_next;
        if (next == this)
            return 0;
        return static_cast<T*>(next);
    }

    void clear() { _next = _prev = this; }
    bool empty() const { return _next == this; }
};


template<class T> class LinkedListMember
{
public:
    LinkedListMember() : _next(0), _prev(0) { }

    void remove()
    {
        _next->_prev = _prev;
        _prev->_next = _next;
    }

    void reseat()
    {
        _next->_prev = this;
        _prev->_next = this;
    }

private:
    LinkedListMember<T>* _next;
    LinkedListMember<T>* _prev;
    friend class LinkedList<T>;
};

#endif // AJLIB_LINKEDLIST_H